{
open PrinterYacc;;
open YaccTypes;;
}

rule token = parse
   ['0'-'9']+   {INT (int_of_string (Lexing.lexeme lexbuf))}
  |['\t']    {TAB}
  |[^ '\n']*eof  {EOF}
  |[^ '\n']    {linenum := !linenum + 1; token lexbuf}
  |[' ']+       {token lexbuf}
  |['\n']     {linenum := !linenum + 1;EOL} 
  |eof       {EOF}
  |"<word>"      {WORD}
  |"<surprisal>"    {SURPRISAL}
  |['0'-'9']+   {INT (int_of_string (Lexing.lexeme lexbuf))}
  |['0'-'9']+ '.' ['0'-'9']+   {FLOAT (float_of_string (Lexing.lexeme lexbuf))}
  |'#' ['A'-'Z''0'-'9']+   {COLOR (Lexing.lexeme lexbuf)}
  |"dashed"|"DASHED"|"Dashed"   {DASHED}
  |"<sentence>"   {SENTENCEBEGIN}
  |"</sentence>"  {SENTENCEEND}
  |"<arc>"       {ARC}
  |['a'-'z' 'A'-'Z']+  {STRING (Lexing.lexeme lexbuf)}
  |[',' '.' ';' ':' '?' '!']+ {STRING (Lexing.lexeme lexbuf)}
