type point = {x: float; y:float};;
type word = {wordInfo: string list; pos: int; startPoint: point list; endPoint: point list; arcs: int; arcPoint: point; surprisal: float};;
type arc = {fromWord: int; toWord: int; title: string; color: string; style: string};;
type sentence = {wordList: word list; arcList: arc list};;


let newPoint = {x=0.0;y=0.0};;

let makeWord wordList = {wordInfo=wordList; pos=0; startPoint=[]; endPoint=[]; arcs=0; arcPoint=newPoint; surprisal=0.0};;
let makeArc i j t c s = {fromWord=j; toWord=i; title=t; color=c; style=s};;
let makeSurp i s = (i, s);;

let rec addPos wl i nl = match wl with
	[] ->(List.rev nl)
	|h::t -> 
	(addPos t (i+1) ({wordInfo=h.wordInfo;pos=i;startPoint=h.startPoint;endPoint=h.endPoint;arcs=h.arcs;arcPoint=h.arcPoint;surprisal=h.surprisal}::nl))

let addToList x l = x::l;;

let makeSentence wl al = 
	let newWL = (addPos (List.rev wl) 0 []) in
		{wordList=newWL; arcList=al};;

let rec matchW w sl = match sl with
    [] -> w
  |sh::st -> if ((fst sh) == w.pos) then {wordInfo=w.wordInfo;pos=w.pos;startPoint=w.startPoint;endPoint=w.endPoint;arcs=w.arcs;arcPoint=w.arcPoint;surprisal=(snd sh)} else (matchW w st);;

let rec matchWS wl sl newWL = match wl with
    [] -> (List.rev newWL)
  |wh::wt -> (let newW = (matchW wh sl) in
	       (matchWS wt sl (newW::newWL)));;

let makeSentenceSurp wl al sl = 
  let posWL = (addPos (List.rev wl) 0 []) in 
  let newWL = (matchWS posWL sl []) in
    {wordList=newWL; arcList=al};;

let linenum = ref 1;; 
