type point = { x : float; y : float; }
type word = {
  wordInfo : string list;
  pos : int;
  startPoint : point list;
  endPoint : point list;
  arcs : int;
  arcPoint : point;
  surprisal : float;
}
type arc = {
  fromWord : int;
  toWord : int;
  title : string;
  color : string;
  style : string;
}
type sentence = { wordList : word list; arcList : arc list; }
val newPoint : point
val makeWord : string list -> word
val makeArc : int -> int -> string -> string -> string -> arc
val makeSurp : 'a -> 'b -> 'a * 'b
val addPos : word list -> int -> word list -> word list
val addToList : 'a -> 'a list -> 'a list
val makeSentence : word list -> arc list -> sentence
val matchW : word -> (int * float) list -> word
val matchWS : word list -> (int * float) list -> word list -> word list
val makeSentenceSurp :
  word list -> arc list -> (int * float) list -> sentence
val linenum : int ref
